using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace mapeditor
{
    public class mapeditor
    {
        public static void Main()
        {

            //Copper ore
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Copper ore",
                                DescriptionOverride = "Copper ore",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Copper ore.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Copper ore.png", 0.4f);
                                    Instance.FixColliders();
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Copper block
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Copper block",
                                DescriptionOverride = "The block contains several types of this block",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Copper block.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    if (!Instance.GetComponent<RandomSpriteBehaviour>())
                                    Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                                    Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                      {
                                         ModAPI.LoadSprite("Blocks/Copper block.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Copper block1.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Copper block2.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Copper block3.png", 0.4f),
                                      };    
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Copper block.png", 0.4f);
                                    Instance.FixColliders();     
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Cut copper
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Cut copper",
                                DescriptionOverride = "The block contains several types of this block",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Cut copper.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    if (!Instance.GetComponent<RandomSpriteBehaviour>())
                                    Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                                    Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                      {
                                         ModAPI.LoadSprite("Blocks/Cut copper.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Cut copper1.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Cut copper2.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Cut copper3.png", 0.4f),
                                      };    
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Cut copper.png", 0.4f);
                                    Instance.FixColliders();     
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Cut copper stairs
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Cut copper stairs",
                                DescriptionOverride = "The block contains several types of this block",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Cut copper stairs.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    if (!Instance.GetComponent<RandomSpriteBehaviour>())
                                    Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                                    Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                      {
                                         ModAPI.LoadSprite("Blocks/Cut copper stairs.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Cut copper stairs1.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Cut copper stairs2.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Cut copper stairs3.png", 0.4f),
                                      };    
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Cut copper stairs.png", 0.4f);
                                    Instance.FixColliders();     
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<PolygonCollider2D>();
                                }
                            }
                        );

            //Cut copper slab
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Cut copper slab",
                                DescriptionOverride = "The block contains several types of this block",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Cut copper slab.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    if (!Instance.GetComponent<RandomSpriteBehaviour>())
                                    Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                                    Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                      {
                                         ModAPI.LoadSprite("Blocks/Cut copper slab.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Cut copper slab1.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Cut copper slab2.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Cut copper slab3.png", 0.4f),
                                      };    
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Cut copper slab.png", 0.4f);
                                    Instance.FixColliders();     
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Tuff
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Tuff",
                                DescriptionOverride = "Tuff",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Tuff.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Tuff.png", 0.4f);
                                    Instance.FixColliders();
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Calcite
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Calcite",
                                DescriptionOverride = "Calcite",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Calcite.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Calcite.png", 0.4f);
                                    Instance.FixColliders();
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Dripstone block
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Dripstone block",
                                DescriptionOverride = "Dripstone block",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Dripstone block.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Dripstone block.png", 0.4f);
                                    Instance.FixColliders();
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Amethyst block
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Amethyst blocks",
                                DescriptionOverride = "The block contains several types of this block",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Amethyst block.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    if (!Instance.GetComponent<RandomSpriteBehaviour>())
                                    Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                                    Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                      {
                                         ModAPI.LoadSprite("Blocks/Amethyst block.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Budding Amethyst.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Amethyst cluster.png", 0.4f),
                                      };    
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Amethyst block.png", 0.4f);
                                    Instance.FixColliders();     
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Azureleaves
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Azureleaves",
                                DescriptionOverride = "The block contains several types of this block",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Azureleaves.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    if (!Instance.GetComponent<RandomSpriteBehaviour>())
                                    Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                                    Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                      {
                                         ModAPI.LoadSprite("Blocks/AzureleavesSmall.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/AzureleavesFlowersSmall.png", 0.4f),
                                      };    
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/AzureleavesSmall.png", 0.4f);
                                    Instance.FixColliders();     
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Tinted glass
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Tinted glass",
                                DescriptionOverride = "Tinted glass",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Tinted glass.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Tinted glass.png", 0.4f);
                                    Instance.FixColliders();
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Powder snow
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Powder snow",
                                DescriptionOverride = "Powder snow",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Powder snow.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Powder snow.png", 0.4f);
                                    Instance.FixColliders();
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<BoxCollider2D>();
                                }
                            }
                        );

            //Axolot
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Brick"),
                                CategoryOverride = ModAPI.FindCategory("Misc."),
                                NameOverride = "Axolot",
                                DescriptionOverride = " ",
                                NameToOrderByOverride = "-C&C",                                                               
                                ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Axolot.png", 0.5f),
                                AfterSpawn = (Instance) =>
                                {
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    if (!Instance.GetComponent<RandomSpriteBehaviour>())
                                    Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                                    Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                      {
                                         ModAPI.LoadSprite("Blocks/Axolot1.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Axolot2.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Axolot3.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Axolot4.png", 0.4f),
                                         ModAPI.LoadSprite("Blocks/Axolot5.png", 0.4f),
                                      };    
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Blocks/Axolot1.png", 0.4f);
                                    Instance.FixColliders();     
                                    foreach (var c in Instance.GetComponents<Collider2D>())
                                    {
                                        GameObject.Destroy(c);
                                    }
                                    Instance.AddComponent<PolygonCollider2D>();
                                }
                            }
                        );

        }
    }
}